/**
 * 郵便番号・住所サジェスト システム
 *
 * @version   1.00.00
 * @copyright (c) 2019 Step One co,.ltd.
 * @license   Commercial License
 * @see       https://www.steponecoltd.com/product/p2as/
 */
{
function _arrayFrom(a) { for (var i = 0, l = a.length, r = []; i < l; i++) { r[i] = a[i]; } return r; }
function _sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _slicedToArray(arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return _sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }
var VERSION = '1.00.00';
var SEARCH_PHP_FILE_PATH = 'AUTO';
var U = undefined,
N = null,
T = true,
F = false,
W = window,
D = W.document;
var $ = 'querySelectorAll';
var MULTI_CSS = ['#s1-p2as-popup { position: absolute; opacity: 0; margin: 0; padding: 0; border: 1px solid #666; background-color: #fff; z-index: 65535; }', '#s1-p2as-popup div { display: inline-block; }', '#s1-p2as-popup div:nth-child(2), #s1-p2as-popup div:nth-child(3) { margin-left: 1px; border-left: 1px dotted #888; padding-left: 1px; }', '#s1-p2as-popup span { display: block; padding: 1px 14px 2px 14px; font-size: 14px; color: #000; cursor: default; }', '#s1-p2as-popup span:hover { background-color: #000088; color: #fff; }'];
var multiInited = F;
var currentPostCode = N;
var init = function init() {
var searchPath = SEARCH_PHP_FILE_PATH,
sElms,
elms,
t;
if (searchPath === 'AUTO') {
t = D[$]('SCRIPT[src*="p2as.js"]');
if (t[0]) {
searchPath = t[0].src.replace(/[^\/]+$/, '') + 'p2as-search.php';
} else {
error('p2as-search.php detection failed.');
}
}
sElms = D[$]('*[data-p2as="set"]');
if (!sElms.length) {
sElms = D[$]('BODY');
}
if (!sElms.forEach) {
sElms = _arrayFrom(sElms);
}
sElms.forEach(function (sElm) {
var conf = {
type: N,
searchPath: searchPath,
fieldMap: {}
},
fMap = conf.fieldMap,
type,
fElms,
key,
pcElms,
val,
r;
fElms = sElm[$]('*[data-p2as]');
if (!fElms.forEach) {
fElms = _arrayFrom(fElms);
}
fElms.forEach(function (fElm) {
key = (fElm.dataset.p2as || '').replace(/ /g, '');
if (!fMap[key]) {
fMap[key] = [];
}
fMap[key].push(fElm);
if (key.indexOf('multi') !== -1) {
type = 'multi';
}
});
if (fMap.jigyosyo || fMap.company) {
type = type || 'jigyosyo';
}
conf.type = type || '1to1';
var change = function change() {
var tVal;
val = '';
pcElms.forEach(function (pcElm) {
val += pcElm.value;
});
if (r = val.match(/^(\d{3})\-?(\d{4})$/)) {
tVal = (r[1] + r[2]) * 1;
if (currentPostCode === tVal) {
return;
}
currentPostCode = tVal;
conf.value = tVal;
conf.origin = val;
request(conf);
}
};
pcElms = fMap['postcode'];
if (pcElms) {
pcElms.forEach(function (pcElm) {
pcElm.addEventListener('keyup', change, false);
pcElm.addEventListener('paste', function() { setTimeout(change); }, false);
});
} else {
error('postcode field not exist.');
}
});
};
var multiInit = function multiInit() {
var styElm, css, i, l;
styElm = D.createElement('style');
styElm.type = 'text/css';
D.getElementsByTagName('HEAD')[0].appendChild(styElm);
css = D.styleSheets[D.styleSheets.length - 1];
for (i = 0, l = MULTI_CSS.length; i < l; i++) {
css.insertRule(MULTI_CSS[i], i);
}
multiInited = T;
};
var request;
if (window.fetch) {
request = function request(conf) {
var src, fOpt, p;
src = conf.searchPath + '?postcode=' + (conf.value + '') + '&type=' + conf.type;
fOpt = {
method: 'GET'
};
p = fetch(src, fOpt);
p.then(function (res) {
if (res.ok) {
return res.text();
} else {
error('network error. (' + res.status + ' ' + res.statusText + ')');
return;
}
}).then(function (body) {
response(body, conf);
}).catch(function (err) {
error('network error. (' + err + ')');
});
};
} else {
request = function request(conf) {
var src, fOpt, req, p;
src = conf.searchPath + '?postcode=' + (conf.value + '') + '&type=' + conf.type;
req = new XMLHttpRequest();
req.open('GET', src, T);
req.addEventListener('readystatechange', function () {
if (req.readyState === 4) {
response(req.responseText, conf);
}
}, false);
req.send(null);
};
}
var response = function response(body, conf) {
var fMap = conf.fieldMap,
cVal = '',
res,
multi,
r;
conf.fieldMap['postcode'].forEach(function (pcElm) {
cVal += pcElm.value;
});
if (cVal !== conf.origin) {
return;
}
if (body.indexOf('{') !== -1 && (r = body.match(/\{(.+)\}/))) {
multi = r[1];
body = body.replace(r[0], '');
}
res = body.match(/^(\d+)([^,]+),([^,]+)(?:,(.+))?$/);
if (!res) {
if (body.indexOf('data no match') !== -1) {
return;
} else {
error('response parse failed.');
return;
}
}
res = res.slice(1);
if (multi) {
res.push(multi);
}
res = res.map(function (v, i) {
return (v || '').replace(/[<>"']/g, '');
});
setField(conf, res);
};
var setField = function setField(conf, res) {
var fMap = conf.fieldMap,
_res = _slicedToArray(res, 5),
prefCode = _res[0],
pref = _res[1],
address = _res[2],
company = _res[3],
multi = _res[4],
oElms,
prefPat,
t,
i,
il,
mb;
if (multi) {
multi = parseMulti(multi, T);
}
t = fMap['prefecture+address'] || fMap['prefecture+address+multi'];
if (t && t[0]) {
if (!t[0].value) {
t[0].value = pref + address;
}
mb = pref + address;
}
t = fMap['prefecture'];
if (t && t[0]) {
if (t[0].type === 'text' && !t[0].value) {
t[0].value = pref;
} else if (t[0].tagName === 'SELECT') {
oElms = t[0][$]('option');
prefPat = [pref, pref.replace(/(?:都|道|府|県)$/, ''), prefCode, prefCode.replace(/^0/, '')];
for (i = 0, il = oElms.length; i < il; i++) {
if (prefPat.some(function (ptn) {
return oElms[i].value === ptn ? T : F;
})) {
oElms[i].selected = T;
break;
}
}
}
}
t = fMap['address'] || fMap['address+multi'];
if (t && t[0] && address) {
if (!t[0].value) {
t[0].value = address;
}
mb = address;
}
t = fMap['jigyosyo'] || fMap['company'];
if (t && t[0] && !t[0].value && company) {
t[0].value = company;
}
if (multi) {
if (!multiInited) {
multiInit();
}
t = fMap['prefecture+address+multi'] || fMap['address+multi'];
openMultiPopup(t[0], mb, multi);
}
};
var parseMulti = function parseMulti(val) {
var first = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
var buf = [],
ret = {},
list = {},
_func,
i,
l,
t,
bef;
if (first && val.indexOf('*') !== -1) {
val = val.replace(/(\d+)\*(\d+)/g, function (s, m1, m2) {
for (i = m1 * 1, l = m2 * 1, t = []; i <= l; i++) {
t.push(i);
}
return t.join(',');
});
}
do {
bef = val;
val = val.replace(/\{([^\{\}]+)\}/g, (s, m) => {
buf.push(m);
return '\t' + (buf.length - 1);
});
if (val === bef) {
break;
}
} while (true);
_func = function func(val, pref) {
var ret = [],
k;
val.split(',').forEach(function (v) {
var p = v.indexOf('\t');
if (p === -1) {
ret.push(v);
k = pref + '|' + v;
v = null;
} else {
t = v.substr(0, p);
ret.push(t);
k = pref + '|' + t;
v = _func(buf[v.substr(p + 1)], k);
}
k = k.replace(/(\d)\|(\d)/, '$1-$2').replace(/\|/g, '');
list[k] = v;
});
return ret;
};
list[''] = _func(val, '');
return list;
};
var openMultiPopup = function openMultiPopup(tElm, base, data) {
var dElm,
pElm,
css = '',
fSize,
val,
crtData,
crtDataGroup = [],
pos,
_evFunc,
len,
div,
limit,
t,
t1,
t2,
w,
h,
i,
l,
k,
br;
val = tElm.value;
crtData = data[val.replace(new RegExp('^' + base), '')];
if (val.indexOf(base) === -1 || !crtData || !crtData.length) {
return;
}
dElm = D.createElement('DIV');
t1 = D.defaultView.getComputedStyle(tElm, '');
t2 = D.defaultView.getComputedStyle(dElm, '');
for (i = 0, l = t1.length; i < l; i++) {
k = t1[i];
if (t1[k] !== t2[k]) {
css += k + ': ' + t1[k] + '; ';
}
}
dElm.style.cssText = css;
fSize = t1.fontSize;
val = val.replace(/</g, '<').replace(/>/g, '>').replace(/\n/g, '<br>');
dElm.innerHTML = val + '<span>.</span>';
dElm.style.position = 'absolute';
dElm.style.overflow = 'hidden';
dElm.style.whiteSpace = "pre";
dElm.style.opacity = '0';
tElm.parentNode.insertBefore(dElm, tElm.nextSibling);
dElm.scrollLeft = tElm.scrollLeft;
pos = {
left: dElm.firstElementChild.offsetLeft,
top: 0
};
pos.left -= dElm.scrollLeft;
t = tElm.getBoundingClientRect();
pos.left += t.left + W.pageXOffset;
pos.top += t.top + W.pageYOffset;
dElm.parentNode.removeChild(dElm);
pElm = D.createElement('DIV');
pElm.id = 's1-p2as-popup';
pElm.style.fontSize = fSize;
len = crtData.length;
div = len >= 20 ? 3 : len >= 10 ? 2 : 1;
limit = Math.ceil(len / div);
for (i = 0, l = len; i < l; i += limit) {
crtDataGroup.push(crtData.slice(i, i + limit));
}
t1 = '';
for (var _i2 = 0; _i2 < crtDataGroup.length; _i2++) {
t2 = crtDataGroup[_i2];
for (i = 0, l = limit - t2.length, br = ''; i < l; i++) {
br += '<br>';
}
t1 += '<div><span>' + t2.join('</span><span>') + '</span>' + br + '</div>';
}
pElm.innerHTML = t1;
D.getElementsByTagName('BODY')[0].appendChild(pElm);
w = pElm.offsetWidth;
h = pElm.offsetHeight;
t1 = D.documentElement.clientHeight;
t2 = W.pageYOffset;
if (pos.top + tElm.offsetHeight + h - W.pageYOffset < t1 ||
pos.top - h < t2) {
pos.top += tElm.offsetHeight - 1;
} else {
pos.top -= h - 1;
}
pElm.style.left = pos.left + 'px';
pElm.style.top = pos.top + 'px';
pElm.style.opacity = '1';
_evFunc = function evFunc(ev) {
var elm = ev.target,
pntElm = elm.parentNode.parentNode,
t;
if (pntElm && pntElm.id === 's1-p2as-popup') {
tElm.value = (tElm.value + '|' + elm.innerHTML).replace(/[<>]/g, '').replace(/(\d)\|(\d)/, '$1-$2').replace(/\|/, '');
setTimeout(function () {
openMultiPopup(tElm, base, data);
}, 350);
} else {
pntElm = D.getElementById('s1-p2as-popup');
}
pntElm.parentNode.removeChild(pntElm);
W.removeEventListener('click', _evFunc);
};
setTimeout(function () {
W.addEventListener('click', _evFunc);
}, 100);
};
var error = function error(mes) {
console.error('[ PostcodeToAddressAutoComplete ERROR ]\n' + mes);
};
W.addEventListener('DOMContentLoaded', init, {
once: T
});
}